program pvs2014BugTest;

{$NOSHADOW}
{ $WG}                     {global Warnings off}

Device = xmega256A3U, VCC = 3.3;
//Device = xmega128A1U, VCC = 3.3;

Define_Fuses
  Override_Fuses;
  NoteBook               = D;
  COMport                = USB;
  LockBits0              = [];
  FuseBits0              = [];
  FuseBits1              = [];
  FuseBits2              = [];
  // Brown-out is obligatory with USB !!!
  FuseBits5              = [BODACT0, BodLevel0, BodLevel1, BodLevel2];
  ProgFlash = true; // or false  program Flash
  ProgEEprom= true; // or false  program EEprom
  AutoRelease    = true; // or false  Release Target    // Wichtig fr Programmierung ber UPP !!

Import SysTick,SerPortD0,TWI_E, WatchDog, SysLEDblink, ADC_B, FAT16_32, USBsmart;

From System Import SystemTime32;

Define
  // XMega USB must use the internal 32MHz OSC. So the system must use the 2MHz OSC
  OSCtype                = int2MHz,
                           PLLmul = 16,
                           prescB = 1,
                           prescC = 1;
  SysTick                = 10;                 // msec
  StackSize              = $0256, iData;
  FrameSize              = $0256, iData;
  TWIprescE              = TWI_BR400; {TWI speed}
  SerPortD0 = 19200, Stop1; {9600 Baud, 1Stopbit}
  RxBufferD0     = 40, iData;
  TxBufferD0     = 50, iData;
  WatchDog = msec2000; // msec8, msec16, msec32, msec64, msec125, msec250,
  // msec1000, msec2000, msec4000, msec8000

// SysLed
//SysLEDblink = 30; {30*SysTick = 300msec}
// alternative
   SysLEDblink = mSec500; {10..1000 msec}
   SysLedPort = @LEDram, $00; // byte-var, polarity

  ADCrefB        = REFintVCC;
  ADCprescB      = 64;                        // prescaler 64
  ADCchansB      = [0..3];

  // MMC_Soft
   FAT16      = MMC_Soft, IData;
   F16_MMCport= PortB.0, PortB.3, PortB.2, PortB.4;
//   F16_MMCport= PortB.7, PortB.3, PortB.2, PortB.4;
  //              /CS      CLK     MOSI     MISO
//SPI
// 2 CS PC7
// 3 MOSI PA6
// 4 VDD
// 5 CLK  PA7
// 6 GND
// 7 MISO PC4

  // MMC_SPI
//  FAT16          = SPI_C, PortC.7, iData;   // SPI_X, SS-Port, SS-PIN, data area
  F16_FileHandles = 2;
  F16_DirLevels  = 2;
  F16_StrLen     = 50;        // only for file of text
  // optional
  F16_MMCspeed   = fast;     // standard, slow, fast

  USBmanufact            = 'PVS Thorsten Deck';       // max 31 bytes
  USBprodName            = 'PVS2014-CPU';           // "     "
  USBpid                 = $1234;
  USBvid                 = $1234;
  USBprodRel             = 201;
  USBcurrent             = 200;
  USBvBUS                = PortA.7;                 // port and pin


Uses UFAT16_32;
Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }
type

  tBuf64                 = Array[0..63] of byte;
  tpBuf64                = Pointer to tBuf64;
  tLogRec = Record
                Date : String[8];
                Time : String[8];
                Text : String[60];
             End;

tInputLinie  = record
                 Zustand    : integer; // Zustand Alarmline
                 IWert      : word;    // aktueller Wert
                 ZustandOLD : integer; // Alter Zustand
                 IBR        : boolean; // nderung vorhanden 1.Zyklus!
             end;

TPVSConfig1 = record
    Kennung: WORD; (* 0 Kennung fr USB Transfer *)
    CMD: WORD; (* 2 Cmd Befehl *)
    WM000C_GesZeitFTTT: WORD; (* 4 Gesamte berbrckungszeit *)
    WM000D_BerZeitFTTT: WORD; (* 6 Berechtigt berbrckungszeit *)
    WM000E_GesZeitFTSS: WORD; (* 8 Gesamte berbrckungszeit *)
    WM000F_BerZeitFTSS: WORD; (* 10 Berechtigt berbrckungszeit *)
    WM0010_GesZeitZKS: WORD; (* 12 Gesamte berbrckungszeit *)
    WM0011_BerZeitZKS: WORD; (* 14 Berechtigt berbrckungszeit *)
    WM0012_GesZeitNutzer: WORD; (* 16 Gesamte berbrckungszeit *)
    WM0013_BerZeitNutzer: WORD; (* 18 Berechtigt berbrckungszeit *)
    WM0014_GesZeitGMS: WORD; (* 20 Gesamte berbrckungszeit *)
    WM0015_BerZeitGMS: WORD; (* 22 Berechtigt berbrckungszeit *)
    WM0016_AufhalteMgnLos: WORD; (* 24 Aufhaltemagnetlos vor Voralarm *)
    WM0017_MotorZeit: WORD; (* 26 Zeit fr Motorverzgerung *)
    WM0018_AufZeitFreigabe: WORD; (* 28 Trffnungszeit *)
    WM0019_Reserve: WORD; (* 30 *)
    WM001A_SelbstHaltResetZeit: WORD; (* 32 Selbsthaltungsresetzeit *)
    WM001b_HupeZeit: WORD; (* 34 HupeZeit *)
    WM001C_StoerZeitNotauf: WORD; (* 36 StrungszeitNotauf *)
    WM001D_StoerungsZeit: WORD; (* 38 Strungzeitverzgerung *)
    WM001E_Konfig1_MX030: WORD; (* 40 Konfig 1 *)
    WM001F_Konfig1_MX031: WORD; (* 42 Konfig 2 *)
    WM0020_Konfig3_MX032: WORD; (* 44 Konfig 3 *)
    WM0021_IN11Func_MX033: WORD; (* 46 IN11 Function *)
    WM0022_IN12Func_MX034: WORD; (* 48 IN12 Function *)
    WM0023_IN13Func_MX035: WORD; (* 50 IN13 Function *)
    WM0024_IN14Func_MX036: WORD; (* 52 IN14 Function *)
    WM0025_IN15Func_MX037: WORD; (* 54 IN15 Function *)
    WM0026_OUT0Func_MX038: WORD; (* 56 OUT0 Function *)
    WM0027_OUT7Func_MX039: WORD; (* 58 OUT7 Function *)
    WM0028_OUT8Func_MX040: WORD; (* 60 OUT8 Function *)
    WM0029_ZeitVerzHM_MX041: WORD; (* 62 Zeit Verzgerte HM Bestromung *)
  end;

TPVSConfig2 = record
    Kennung: WORD; (* 0 Kennung fr USB Transfer *)
    CMD: WORD; (* 2 Cmd Befehl *)
    WM002A_Konfig4_MX042: WORD; (* 4 Konfig 4 *)
    WM002B_LEDFTT_MX043: WORD; (* 6 LED Zuordnung FTTT *)
    WM002C_LEDFWSS_MX044: WORD; (* 8 LED Zuordnung FWSS *)
    WM002D_LEDS1_MX045: WORD; (* 10 LED Zuordnung Sonder 1 *)
    WM002E_LEDS2_MX046: WORD; (* 12 LED Zuordnung Sonder 2 *)
    WM002F_Konfig5_MX047: WORD; (* 14 Konfig 5 *)
    WM0030_RadarDeadTime_MW048: WORD; (* 16 Radar DeadTime *)
    WM0031_RadarTriggerTime_MW049: WORD; (* 18 Radar Trigger Time *)
    WM_Reserve_020: WORD; (* 20 *)
    WM_Reserve_022: WORD; (* 22 *)
    WM_Reserve_024: WORD; (* 24 *)
    WM_Reserve_026: WORD; (* 26 *)
    WM_Reserve_028: WORD; (* 28 *)
    WM_Reserve_030: WORD; (* 30 *)
    WM_Reserve_032: WORD; (* 32 *)
    WM_Reserve_034: WORD; (* 34 *)
    WM_Reserve_036: WORD; (* 36 *)
    WM_Reserve_038: WORD; (* 38 *)
    WM_Reserve_040: WORD; (* 40 *)
    WM_Reserve_042: WORD; (* 42 *)
    WM_Reserve_044: WORD; (* 44 *)
    WM_Reserve_046: WORD; (* 46 *)
    WM_Reserve_048: WORD; (* 48 *)
    WM_Reserve_050: WORD; (* 50 *)
    WM_Reserve_052: WORD; (* 52 *)
    WM_Reserve_054: WORD; (* 54 *)
    WM_Reserve_056: WORD; (* 56 *)
    WM_Reserve_058: WORD; (* 58 *)
    WM_Reserve_060: WORD; (* 60 *)
    WM_Reserve_062: WORD; (* 62 *)
  end;


{--------------------------------------------------------------}
{ Const Declarations }
CONST

  // PVS-Gerte ID und Version
  GerID   : Word = $0F1F; // Gerte ID
  Version : Word = $1; // Hauptversion gefolgt vom Build

// Kennungen XFER USB
  cmdWrite        : Word = $FFFF; // Schreibbefehl
  cmdCompare      : WORD = $0F0F; // vergleich starten
  cmdRead         : Word = $0000; // Lesebefehl
  kenCfgBlock1    : Word = $0001; // Config Block 1
  kenCfgBlock2    : Word = $0002; // Config Block 2
  kenCfgBlock3    : Word = $0003; // Config Block 3
  kenCfgBlock4    : Word = $0004; // Config Block 4
  kenOnline       : Word = $0F01;

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
VAR
 byteZahl :        byte;
 byteZahl1 :        byte;
 ww        :        word;
 DebugZyklus :      word;
 
// these two buffers must be aligned to even addresses !!
  RxBuf                 : tBuf64, align2;  // USB incomming Buffer
  TxBuf                 : tBuf64, align2;  // USB outgoing Buffer



// Input  Onboard
   HxIN_SOFTRESET    [@PINE, 3 ] : bit;
   HxIN_RUNSTOP      [@PINR, 0 ] : bit;
   HxIN_SERVTAST     [@PINR, 1 ] : bit;
   HxIN_ZBV0         [@PINF, 6 ] : bit;
   HxIN_3            [@PINF, 1 ] : bit;
   HxIN_11           [@PINF, 4 ] : bit;
   HxIN_12           [@PINF, 7 ] : bit;
   HxIN_13           [@PINF, 5 ] : bit;
   HxIN_14           [@PINF, 3 ] : bit;
   HxIN_15           [@PINF, 2 ] : bit;

// OutPut Onboard
   HxOUT_K17         [@PORTF, 0 ] : bit;
// Test LED
   HxOK              [@PORTB, 7 ] : bit;


// Ab hier die EEPROM VARs Parameter
{$EEPROM}
//Structconst
 Cfg1   :   TPVSConfig1;
 Cfg2   :   TPVSConfig2;
{--------------------------------------------------------------}
{ functions }
{--------------------------------------------------------------}
procedure DebugOut( OutStr : String[100] );
begin
  Writeln(SerOutD0,OutStr);
end; //Ende Debug Out

//-----------------------------------------------------------------------------
  //  User function to receive EP0 ControlRequests from Host
Function myUSB_ControlRequest(bRequest : Byte; wValue : word) : boolean;
// need always answer from device
Var
  b : byte;
begin
  case (bRequest) of
    $00 : // do a real RESET
          USB_ControlSend(nil, 0);
          mDelay(100);
          HardWareReset;
        |
    $20 : // write to a Port
          PortF:= Lo(wValue);
          USB_ControlSend(nil, 0);  // ACK the request
          Return(True);
        |
    $30 : // Read a Port
          b:= PinF;
          USB_ControlSend(@b, 1);  // send back ACK and PortF status
          Return(True);
        |
    $40 : // do Beep
          USB_ControlSend(NIL, 0);  // send back ACK
          Return(True);
        |
  else
    USB_ControlSend(nil, 0);  // unknown vendor request, do an ACK
    Return(true);
  endcase;
end;

{--------------------------------------------------------------}
Procedure USB_CheckRxTx;
Var Count, C: byte;
 InBuffer  : Array[0..31] of WORD;

begin

  if USB_RxDataAvail then
    Count:= USB_RxCount;

 DebugOut('USB Datenanzahl:'+ ByteToHex( Count ));


// ziehe Block in Zwischenspeicher zum prfen!
copyblock(@rxbuf, @InBuffer, sizeof(rxbuf));

// Prfe Eingangsblock
if InBuffer[0] = kenCfgBlock1
  then
   if InBuffer[1] = cmdWrite
    then
    // Prfe ob es einen Unterschied gibt um EEPROM Speicher zu schonen....
     if not CompareBlock(@rxbuf, @Cfg1, sizeof(rxbuf))
      then
        copyblock(@rxbuf, @Cfg1, sizeof(rxbuf));
         DebugOut('CFG1; nderungen bernommen.');
      endif;
       DebugOut('Cmd: '+IntToStr(InBuffer[1]) +' / Kennung: '+IntToStr(InBuffer[0]));
     endif; // Ende bei Write

elsif InBuffer[0] = kenCfgBlock2
 then
   if InBuffer[1] = cmdWrite
    then
    // Prfe ob es einen Unterschied gibt um EEPROM Speicher zu schonen....
     if not CompareBlock(@rxbuf, @Cfg1, sizeof(rxbuf))
      then
        copyblock(@rxbuf, @Cfg2, sizeof(rxbuf));
         DebugOut('CFG2; nderungen bernommen.');
      endif;
       DebugOut('Cmd: '+IntToStr(InBuffer[1]) +' / Kennung: '+IntToStr(InBuffer[0]));
     endif; // Ende bei Write
 endif; // Ende



    // fill TxBuf with data, then...
    //USB_TxSend(@TxBuf,64);
    USB_RxSetBuf(@RxBuf);            // we need more data ..

//              copyblock(@rxbuf, @ONLStatus, sizeof(rxbuf));

  endif;
end;



procedure InitPorts;
begin
// INIT Werte IOs

//Reset Input Taste
  PIN3CTRLE := %01011000; // pullup und INVERT
  DDRE.3:= 0;  // 0=EINGANG  1=Ausgang
//Run Stop Schalter
  PIN0CTRLR := %01011000; // pullup und INVERT
  DDRR.0:= 0;  // 0=EINGANG  1=Ausgang
//ServTaste
  PIN1CTRLR := %01011000; // pullup und INVERT
  DDRR.1:= 0;  // 0=EINGANG  1=Ausgang
//IN ZBV0
  PIN6CTRLF := %01011000; // pullup und INVERT
  DDRF.6:= 0;  // 0=EINGANG  1=Ausgang
//IN 3
  PIN1CTRLF := %01011000; // pullup und INVERT
  DDRF.1:= 0;  // 0=EINGANG  1=Ausgang
//IN 11
  PIN4CTRLF := %01011000; // pullup und INVERT
  DDRF.4:= 0;  // 0=EINGANG  1=Ausgang
//IN 12
  PIN7CTRLF := %01011000; // pullup und INVERT
  DDRF.7:= 0;  // 0=EINGANG  1=Ausgang
//IN 13
  PIN5CTRLF := %01011000; // pullup und INVERT
  DDRF.5:= 0;  // 0=EINGANG  1=Ausgang
//IN 14
  PIN3CTRLF := %01011000; // pullup und INVERT
  DDRF.3:= 0;  // 0=EINGANG  1=Ausgang
//IN 15
  PIN2CTRLF := %01011000; // pullup und INVERT
  DDRF.2:= 0;  // 0=EINGANG  1=Ausgang

//OUT_K17
  //PIN0CTRLF := %00000000; // pullup und INVERT
  DDRF.0:= 1;  // 0=EINGANG  1=Ausgang
//   HxOK              [@PORTB, 7 ] : bit;
  //PIN0CTRLF := %00000000; // pullup und INVERT
  DDRB.7:= 1;  // 0=EINGANG  1=Ausgang


end InitPorts;
{--------------------------------------------------------------}

procedure DebugPrinting;
var
 inbuffer : byte;
  st        : string[16];
  CLEAR     : string[4];
  cESC      : CHAR;
begin

 DebugZyklus:= DebugZyklus+1;
if DebugZyklus >= 65000 then
  DebugZyklus:=0;

 CLEAR:=CHAR(27)+CHAR(91)+'2J';    // Lsche Bildschirm
  DebugOut( CLEAR );
    st:= 'B0: '+IntToStr(ww:6);
    DebugOut( st);
    st:= 'B3: '+IntToStr(ww:6);
    DebugOut( st);
  endif; // Ende DebugZyklus
end; // ENDE

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  USB_SetControlCallback(@myUSB_ControlRequest); // optional, if you need it!
  USB_Init(@RxBuf);        // Attach USB and connect RxBuf for FIRST RX INT

InitPorts;
 EnableInts($87);

// Start-Meldung
DebugOut( 'DEGUG; System gestartet....');
DebugOut( ' ');


//WatchDogStart;
 // SetSysTimer( Time100ms, 10); // Timer starten
  SysLEDflashOn( 0 ); // OKLED; // Zyklus LED starten

 loop   // Main LOOP
  USB_ControlJob;        // or run in Systick every < 40ms
    USB_CheckRxTx;
    //SysLEDflashOn( 0 ); // OKLED; // Zyklus LED starten
      DebugPrinting;
              HxOK:= NOT (LEDram.0); // Setzte OK LED zum flashen ...TEST



//  WatchDogTrig;
 endloop;
end pvs2014BugTest.
